<?php include_once 'codebase/hyperframe.php' ?><!doctype html>
<html>
<html>
<head>
   <TITLE>The menu system </TITLE>
   <META NAME="description"  CONTENT="How to create Hyperframe menus">
   <META NAME="keywords" CONTENT="hyperframe !cms, menus, cascading, sidebar, dropdown">
   <META NAME="hf_frame" CONTENT="">
   <META NAME="hf_menu" CONTENT="">
   <META NAME="hf_hide" CONTENT="">
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; utf-8">
   <META NAME="GENERATOR" CONTENT="Hyperframe !CMS">
   <META NAME="Author" CONTENT="IWR Consultancy">
</head>

<body>
<h1>Menus</h1>

<p><strong>The Hyperframe menu system is designed to provide a highly functional pair of cascading menus, one optimised for top-of-page usage and the other for sidebar usage. These menus are capable of handling a very large number of links without overcrowding the page, and provide a quick and intuitive method of navigating the site. In most cases they will reduce or even eliminate the need for hyperlinks within the body text of pages, thus saving greatly on&nbsp; link-maintenance work by the webmaster.&nbsp;</strong></p>

<p>A key design objective has been to create expanding menus which do not require tedious page reloads when navigating from section to section, giving virtually instantaneous access to any menu section. The sidebar menu gives a clear indication of which page is currently open, and which site section it belongs to. This also eliminates the need for &#39;breadcrumbs&#39; -the menu providing such placeholder information in itself.&nbsp;</p>

<p>In the event that a visitor is unable to use the cascading menus, an automatically-generated sitemap page provides a very traditional and text-interface friendly list of the menu links.</p>

<p>Menu contents are determined by a simple textfile structure, the files being in sitecfg/ By default, the lefthand cascading menu is built from tree.mnu, and the top bar menu from quicklink.mnu The file structure is as follows:</p>

<pre>
[SectionText=SectionDescription
    LinkText=Hyperlink=LinkDescription
    [SectionText=SectionDescription
       LinkText=Hyperlink=LinkDescription
    ]
]</pre>

<p><img alt="The menu editor" class="caption float-right" onclick="hf_imgzoom_popup(this.src)" src="img/editing/menueditor.png" style="margin: 5px 15px; width: 438px; height: 275px; border-width: 1px; border-style: solid;" />Square brackets enclose a menu sublevel. Sublevels may be nested to any depth, but in the case of lefthand menus please take account of the amount of screen space taken up by excessvely lengthy or multiply-nested entries. Basically, it is best to keep the LinkText short and use the Description to provide clarification where needed.</p>

<p>By default, sublevels are collapsed, but preceding a section&#39;s left bracket with + will cause that section to be expanded by default. The sublevel containing the current page and its parents are automatically expanded. &#39;Text&#39; is what is displayed in the menu. Descriptions are optional, and if present are shown when the mouse is hovered over the item.</p>

<p>It is permissible to have a menu without sublevel brackets, in which case it will appear as a traditional flatfile menu.</p>

<p>For local pages, the hyperlink should consist of the plain filename only, for example <i>mypage.pgp</i> Do not add http://, the domain,&nbsp; or other prefixes. If your site contains subdirectories, the files in these should be referred to by a <i>relative</i> path from the root of the website. For example, <i>subsection/pageone.html</i></p>

<p>Don&#39;t worry about what will happen if the page bearing the menu is not in the default location - the menu system will take care of that. All links should be relative to the base directory of the website -the one with codebase, sitecfg, frame, etc in it. It doesn&#39;t actually matter if you start the local link with a / or not, but standard practice is that you should not.</p>

<p>To refer to the site&#39;s homepage -the default file in the top directory level- the hyperlink should be null, or a / on its own.&nbsp;</p>

<p>For offsite links, <i>do</i> include http:// or https:// and the full domain - this tells the system that you are entering a link to another website. Such links will automatically open in a new browser tab, so as to retain the&nbsp;tab open on your site. This behaviour is generally preferred on business sites, where a visitor directed permanently off your site is potentially a lost sale.&nbsp;</p>

<p>Items are NOT enclosed in quotes. (Unless of course you want quotes displayed onscreen). Indenting is optional and has no effect on behaviour. The syntax is relatively tolerant of mistakes, and will attempt to display some kind of menu even if there are unbalanced brackets or suchlike present. That is not of course an excuse for careless menu coding, but resilient systems are always preferable to fragile ones.</p>

<p>A menu editor is included, under Edit&gt;Edit Menu. This allows you to test your changes before saving. Previous menu versions are included in the rollback archive, in case you should need to undo a serious mistake. Alternatively, a menu can be prepared in any texteditor (Geany is strongly recommended) and uploaded by ftp.</p>

<h4>Extensionless URLs and subdirectories</h4>

<p>On sites with these features, and in order to be able to distinguish between a filename and a subdirectory, the following rules apply:</p>

<ul>
  <li><strong>All references to a subdirectory must terminate in a / </strong></li>
  <li><strong>All menu references to files shall have the extension present</strong></li>
</ul>

<p>To make the all local menu links appear as an <a href="extensionless.php">extensionless URL</a> in the browser bar, simply change the multiviews setting in siteini.php from 0 to 1.&nbsp; There is no need to remove the extensions from the menu entries, in fact this should <em>not</em> be done as it would make it difficult for the location-tracking logic to tell which file is being referenced.</p>

<h4>Compatibility:</h4>

<p>The new menu system in v4 will work in most modern browsers, including Firefox 3 on, IE8-on, and most mobile browsers.&nbsp; It will also work in IE6/7 with full functionality but with a somewhat inelegant display.</p>

<p>The change to a click-operated or tap-operated top menu as opposed to mouseover-operated, is mainly in the interests of touchscreen devices, although we think you will agree that it is more ergonomic all-round, even on mouse-driven desktops. In particular, with click operation it will not have any adverse result if in navigating to an item you allow the mouse cursor to stray outside of the menu box for a short while. That, and passing the mouse over the menu area enroute to an inpage link&nbsp; will not cause spurious menu popups.</p>

<p>The new menus have been tested on iPad, Android and Kindle Fire, and show good ergonomics.</p>

<p>An issue has been noted on Galaxy Tab 4 tablets, in that the auto-zoom feature these possess makes it difficult to activate menu items, the auto-zoom &#39;stealing the click&#39; away from the menu link. This, on links that don&#39;t need zooming anyway as they are perfectly large enough to read! Since this auto-zoom feature is problematic in other situations too, we hope that Samsung may modify it in the near future.&nbsp;Galaxy Tab 3 and earlier models are not affected.&nbsp;</p>

<p>&nbsp;</p>

</body>
</html>