<?php include_once 'codebase/hyperframe.php' ?><h1>Image Upload</h1>

<h3>The quick image upload and link tool&nbsp;</h3>

<p>Image upload and linking is an area which has had an extensive overhaul in this version. There are now two image-related buttons, <em>Image (Linking)</em>&nbsp; and <em>Quick Image Upload</em>. The Image button functions in a broadly similar way to the original, whereas <em>Quick Image Upload</em> is an entirely new&nbsp; concept. Use whichever you prefer, although <em>Quick Image Upload</em> is more suited to the initial placement of an image on a page, whilst <em>Image</em> is typically used to modify an existing image link.</p>

<p>This page covers the new <em>Quick Image</em> tool. For the <a href="images.php">Image Dialog</a> , see its separate page.</p>

<p>The Quick Image tool was developed in response to user feedback which suggests that whilst the standard Image tool works well for adjusting existing image links, the process of uploading new images is rather complex and unwieldy, involving too may separate steps in too many disparate windows. Thus, the idea here is to provide all that&#39;s needed to get from having a photo or graphic on your own local computer&#39;s disk, to having that image on your webpage, and to cover that entire process in a single, intuitive dialog box. The intention is that the dialog should handle most of the technical aspects like file naming, leaving you to decide on only those items which affect the page appearance. &nbsp;</p>

<p><img alt="The Quick Image button" class="float-left" src="img/editing/quickbutton.png" style="width: 34px; height: 32px; margin-top: 20px; margin-bottom: 20px;" />To use Quick Image, first of all click the insertion point in your document, where the image will be placed -don&#39;t worry if this is not exact, it can easily be changed later. Then press the Quick Image button on the editor toolbar -as shown at left. The resulting dialog, shown below, has three sections. The top shows images already on the webserver, the centre section is for uploading from your own computer, whilst the lower is for positioning your uploaded or selected image in the page.<img alt="The Quick Image dialog" class="caption float-right" onclick="hf_imgzoom_popup(this.src)" src="img/editing/quickimg.png" style="width: 498px; height: 489px; margin: 15px;" /></p>

<h3>Existing Images</h3>

<p>The top panel has two tabs; images already uploaded for this page, and images for all pages at this site level. &#39;Uploaded for this page&#39; means images uploaded via Quick Upload.&nbsp; Images used in the page which arrived via other methods of uploading will not be listed here. &#39;All Images&#39; shows the contents of the &#39;img/&#39; subdirectory below the location of this webpage. Unlike the standard Image dialog, there is no option to change this location, or to browse to other locations. Thus, for straightforward sites the user need not worry about the technicalities of exactly where images are uploaded to; that is taken care of by the system.</p>

<p>To use an image from either tab in your page, click it once. The link will be transferred to the Link URL box in the third section. Note: To use images from elsewhere on the webserver, open the standard Image dialog.</p>

<h3>Upload</h3>

<p>To upload an image from your own computer, click the button in the middle section. This will take you to a file-selector dialog which is generated by your computer&#39;s operating system. Thus, its appearance may vary depending on computer type. In this tool, you may select and upload only one image at a time. The image must have a jpg, jpeg, png or gif extension, otherwise it will be refused by the server. Note that not all operating systems allow the choice to be limited to such files, thus it may possible to select file types which will be rejected on upload.</p>

<p>Under Smart Sizing, you have the option to set the <em>maximum</em> width and height for the uploaded copy of your image. This will not alter the original file. It will only downsize the uploaded copy <em>if</em> one or other dimension exceeds the maximum you have set. This feature is useful when uploading a digital camera image of pixel dimensions far too large for webpage display. It should not however be regarded as a substitute for proper image preparation work.&nbsp;</p>

<p>For images inline with your text, 400x400 or less is a sensible choice, for page header banners or standalone images you might wish to use 640x480 or 800x600. Only use sizes larger than 800x600 if you want the image to cover the entire page.</p>

<p>Once ready, press Upload. The&nbsp; progress will be displayed in the top section.</p>

<h3>Naming:</h3>

<p>The name for the uploaded copy is automatically generated, and may in some cases differ from the name on your local computer. It is displayed for reference, but you cannot change it. Again it&#39;s done like this to avoid bothering the user with technicalities, such that for the most part the upload process &#39;just works.&#39; Normally, each image uploaded receives a distinct name. Therefore you do not need to concern yourself over naming clashes. If you do need to replace an existing image, then tick the over-write option, which turns the auto-rename mechanism off.&nbsp; &nbsp;</p>

<h3>Positioning / Alignment</h3>

<p>Once you have selected your image, you will probably want to adjust how it displays in the page. In the third section, the horiziontal position of the image is handled in one step, and covers left, center or rigthhand alignment, along with the choice of the image being in its own space, or allowing the surrounding text to &#39;flow&#39; around it.</p>

<p>The vertical position is determined by the insertion point, and there are no controls in the dialog for this. Instead, you adjust this by dragging and dropping the image in the main editor. Note that when you are using text flow-around it is generally better to place the insertion point at the start of a paragraph, and this should always be on the left of page (for left-to-right languages) even if the image is floated to the right.</p>

<p>Since the default HTML image alignment is not typically useful for photos or the like, the &#39;document default&#39; option in fact applies a &#39;plain&#39; image class instead of the <em>actual</em> default. As supplied this positions the image to the left on its own, though that can be changed in the stylesheet. The intention here is that the webmaster set the &#39;plain&#39; style as required, so that it will apply to all images where no other choice is made. That keeps things consistent and avoids the problems that the actual default/unspecified alignment creates.</p>

<h3>Spacing</h3>

<p>The supplied stylesheet provides a small space between the image and surrounding text. To keep things simple this is not adjustable in the Quick dialog. In the unlikely event that adjustment is needed, use the standard dialog after completing the Quick process.</p>

<h3>View in popup</h3>

<p>This option adds code to the image link allowing the user to click once to see the image fullsize in a popup. (actually a layer, since that avoids the need to open a new window)&nbsp; This is only of use where the image is subsequently shrunk with the mouse handles in the editing window. Otherwise, the popup will be of the same size as the parent image. This option should <em>not</em> be used if it is intended to subsequently add a hyperlink (to another webpage) to the image.&nbsp;</p>

<h3>Captions</h3>

<p>The Quick Image dialog provides a simple means of placing an explanatory caption below an image. This caption is effectively attached to the image, and will follow it if you drag and drop the image. To use this, type your caption into the&nbsp; box. Now select the caption position from the options below it. The caption is not displayed in page editing mode. To see your caption you must either preview your work, or else exit from editing mode. It&#39;s done like this to ensure that the captions are kept separate from the normal page text. You can, if necessary, alter the appearance of captions by editing your frame.css file.</p>

<h3>Use as a Link</h3>

<p>You may wish to use your image as a clickable link to another webpage. If so, you must make this setting on the second tab of the conventional Image dialog, after the Quick Upload has been completed. Since the majority of images are not used as links it was felt that adding this functionality to the Quick dialog would be needless complication.</p>

<h3>Files and Locations</h3>

<p>As mentioned, Quick Image decides the locations for files itself. This is an img/ subdirectory under whatever level of the site the parent webpage is in. Thus if you want to link images between pages in different site sections, you must use the standard tool instead.&nbsp;</p>

<p>The uploaded file is given a name consisting of the webpage filename minus its extension, an underscore, and the original image filename. This is felt to make it easier for the inexperienced webmaster to identify which images were uploaded for use in which page of the site. That does not of course preclude an image uploaded for one page being displayed in another, or even in several. However, it is felt that it simplifies things considerably by making it possible to show only the files which are<em> likely</em> to be required for a particular page.</p>

<h3>Making changes</h3>

<p>Quick Image is primarily intended for the initial upload and linking of images. It <em>can</em> be used to make changes to existing image links, provided that the image in question is selected in the editor before launching. Note however that the properties of the existing link will not be transferred to the Quick Image dialog; you must set them over again. For other changes, use the standard Image dialog.</p>

<h3>Help</h3>

<p>Almost all of the Quick options have detailed help which is shown as a callout box when the mouse is hovered over the item. If in doubt, consult these.</p>

<p>&nbsp;</p>
